// Copyright (c) 2024 Celestino Amoroso (celestino.amoroso@gmail.com).
// All rights reserved.

// context-helpers.go
package expr

func cloneContext(sourceCtx ExprContext) (clonedCtx ExprContext) {
	if sourceCtx != nil {
		clonedCtx = sourceCtx.Clone()
	}
	return
}

func exportObjects(destCtx, sourceCtx ExprContext) {
	exportAll := isEnabled(sourceCtx, control_export_all)
	// Export variables
	for _, refName := range sourceCtx.EnumVars(func(name string) bool { return exportAll || name[0] == '@' }) {
		refValue, _ := sourceCtx.GetVar(refName)
		exportVar(destCtx, refName, refValue)
	}
	// Export functions
	for _, refName := range sourceCtx.EnumFuncs(func(name string) bool { return exportAll || name[0] == '@' }) {
		if info, _ := sourceCtx.GetFuncInfo(refName); info != nil {
			exportFunc(destCtx, refName, info)
		}
	}

}
